<script>
import { GlButton } from '@gitlab/ui';
import { v4 } from 'uuid';
import {
  DuoWorkflowStatus,
  isTerminated,
  isApprovingPlan,
  isAwaitingUserInput,
} from '../../../../common/duo_workflow_status';
import MessageLog from './message_log.vue';
import AgentMessage from './messages/agent.vue';
import UserMessage from './messages/user.vue';
import SystemMessage from './messages/system.vue';
import WorkflowEndMessage from './messages/workflow_end.vue';

const COMPONENT_FOR_MESSAGE_TYPE = {
  agent: AgentMessage,
  user: UserMessage,
  tool: SystemMessage,
  workflow_end: WorkflowEndMessage,
};

export default {
  name: 'DuoWorkflowChat',
  components: {
    GlButton,
    MessageLog,
  },
  props: {
    isSendingEvent: {
      type: Boolean,
      required: false,
      default: false,
    },
    uiChatLog: {
      type: Array,
      required: true,
    },
    status: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      pendingUserMessages: [],
      scrollToMessage: true,
      isScrolling: false,
      isLoading: false,
    };
  },
  watch: {
    uiChatLog(uiChatLog) {
      this.pendingUserMessages = [
        // When receiving new log, we clear the pending messages queue if they are present on the network response
        ...this.pendingUserMessages.filter(
          (message) =>
            !this.uiChatLog.find(
              (loggedMessage) => message.correlation_id === loggedMessage.correlation_id,
            ),
        ),
      ];
    },
  },
  methods: {
    isLastHighlighted(messages, index) {
      return messages.findLastIndex((m) => m.highlight) === index;
    },
    componentForMessageType(messageType) {
      return COMPONENT_FOR_MESSAGE_TYPE[messageType];
    },
    async onChatSend(message) {
      this.isLoading = true;
      const event = this.hasHighlight ? 'response' : 'message';
      const correlationId = v4();
      this.$emit(event, { message, correlation_id: correlationId });
      this.pendingUserMessages = [
        ...this.pendingUserMessages,
        {
          content: message,
          message_type: 'user',
          timestamp: new Date(),
          correlation_id: correlationId,
        },
      ];
      await this.$nextTick();
      this.isLoading = false;
    },
  },
  computed: {
    chatPromptPlaceholder() {
      switch (this.status) {
        case DuoWorkflowStatus.PLAN_APPROVAL:
          return 'Request plan changes';
        case DuoWorkflowStatus.INPUT_REQUIRED:
          return 'Clarify implementation details';
        default:
          return 'Message';
      }
    },
    messages() {
      const messages = [...this.uiChatLog, ...this.pendingUserMessages].sort(
        (a, b) => new Date(a.timestamp) - new Date(b.timestamp),
      );

      if (this.isChatAvailable) {
        const [lastMessage, ...rest] = messages.reverse();
        return [...rest.reverse(), { ...lastMessage, highlight: true }];
      }

      return messages;
    },
    isApprovingPlan() {
      return isApprovingPlan(this.status);
    },
    isDuoWorking() {
      return (!isAwaitingUserInput(this.status) && !this.isTerminated) || this.isSendingEvent;
    },
    isChatAvailable() {
      return isAwaitingUserInput(this.status) && !this.isSendingEvent;
    },
    needsInput() {
      return this.status === DuoWorkflowStatus.INPUT_REQUIRED;
    },
    isTerminated() {
      return isTerminated(this.status);
    },
    hasEndMessage() {
      return Boolean(this.uiChatLog.find((message) => message.message_type === 'workflow_end'));
    },
  },
  predefinedPrompts: [],
};
</script>
<template>
  <div>
    <message-log
      :chat-prompt-placeholder="chatPromptPlaceholder"
      :messages="messages"
      :is-chat-available="isChatAvailable"
      :is-duo-working="isDuoWorking"
      input-disabled-text="You can message only when your input is needed."
      @send-chat-prompt="onChatSend"
    >
      <template #message="{ message }">
        <component
          :is="componentForMessageType(message.message_type)"
          :message="message"
          data-testid="workflow-message"
        />
      </template>
      <template v-if="isApprovingPlan" #chat-footer>
        <div class="gl-mb-4 gl-gap-x-4 gl-flex gl-items-center">
          <gl-button size="small" icon="play" variant="confirm" @click="$emit('accept-plan')">
            Approve plan
          </gl-button>
        </div>
      </template>
    </message-log>
  </div>
</template>
